/*
   Compare with
      http://threejs.org/examples/#webgl_geometries
*/
import java.awt.Color;
import java.io.File;

public class Geometries
{
   public static void main(String[] args)
   {
      // Creat an array of models
      Model[] models = new Model[15];

      int j = -1;

      // row 1
      j++;
      models[j] = new Model();
      models[j].addSubModel(new ObjSimpleModel(new File("resources\\great_rhombicosidodecahedron.obj")));
      models[j].modelTranslate(-4, 0, -4);
      models[j].modelScale(0.18, 0.18, 0.18);
      models[j].getSubModel(0).setColor(Color.red);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new Model());
      models[j].getSubModel(0).addSubModel(new FrustumCircularModel(10, 10, 0.5, 1, 1));
      models[j].getSubModel(0).getSubModel(0).modelTranslate(0, -0.5, 0);
      models[j].modelTranslate(-4, 0, -2);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).getSubModel(0).setColor(Color.orange);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new Model());
      models[j].getSubModel(0).addSubModel(new CubeModel(1, 1, 1));
      models[j].getSubModel(0).getSubModel(0).modelTranslate(-0.5, -0.5, -0.5);
      models[j].modelTranslate(-4, 0, 0);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).getSubModel(0).setColor(Color.lightGray);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new Axes3DModel(1, 1, 1, Color.red, Color.green, Color.blue));
      models[j].modelTranslate(-4, 0, 2);
      models[j].modelScale(1.0, 1.0, 1.0);
      //models[j].getSubModel(0).setColor(Color.blue);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new SphereModel(30, 30, 1));
      models[j].modelTranslate(-4, 0, 4);
      models[j].modelScale(1.0, 0.5, 0.5);
      models[j].getSubModel(0).setColor(Color.lightGray);

      // row 2
      j++;
      models[j] = new Model();
      models[j].addSubModel(new CylinderModel(30, 30, 0.5, 1));
      models[j].modelTranslate(0, 0, -4);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).setColor(Color.blue.brighter().brighter());

      j++;
      models[j] = new Model();
      models[j].addSubModel(new ObjSimpleModel(new File("resources\\horse.obj")));
      models[j].modelTranslate(0, 0, -2);
      models[j].modelScale(0.2, 0.2, 0.2);
      models[j].getSubModel(0).setColor(Color.pink);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new GRSModel(new File("resources\\grs\\vinci.grs")));
      models[j].modelTranslate(0, 0, 0);
      models[j].modelScale(1.5, 1.5, 1.5);
      models[j].getSubModel(0).setColor(Color.blue);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new TetrahedronModel());
      models[j].modelTranslate(0, 0, 2);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).setColor(Color.cyan);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new ObjSimpleModel(new File("resources\\small_rhombicosidodecahedron.obj")));
      models[j].modelTranslate(0, 0, 4);
      models[j].modelScale(0.2, 0.2, 0.2);
      models[j].getSubModel(0).setColor(Color.magenta);

      // row 3
      j++;
      models[j] = new Model();
      models[j].addSubModel(new PanelModel(-5, 5, -5, 5));
      models[j].modelTranslate(4, 0, -4);
      models[j].modelScale(0.2, 0.2, 0.2);
      models[j].getSubModel(0).setColor(Color.green.darker().darker());

      j++;
      models[j] = new Model();
      models[j].addSubModel(new GRSModel(new File("resources\\grs\\bronto.grs")));
      models[j].modelTranslate(4, 0, -2);
      models[j].modelScale(2.0, 2.0, 2.0);
      models[j].getSubModel(0).setColor(Color.red);

      j++;
      models[j] = new Model();
      models[j].addSubModel( new TorusModel(30, 30, 0.75, 0.25));
      models[j].modelTranslate(4, 0, 0);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).setRandomColors();

      j++;
      models[j] = new Model();
      models[j].addSubModel( new OctahedronModel() );
      models[j].modelTranslate(4, 0, 2);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).setColor(Color.blue);

      j++;
      models[j] = new Model();
      models[j].addSubModel(new Model());
      models[j].getSubModel(0).addSubModel(new ConeModel(30, 30, 0.5, 1));
      models[j].getSubModel(0).getSubModel(0).modelTranslate(0, -0.5, 0);
      models[j].modelTranslate(4, 0, 4);
      models[j].modelScale(1.0, 1.0, 1.0);
      models[j].getSubModel(0).getSubModel(0).setColor(Color.yellow);


      Model xzPlane = new PanelModel(-6, 6, -7, 7);
      xzPlane.setColor(Color.darkGray);
      // x, y and z axes
      Vertex x1 = new Vertex(-6, 0, 0);
      Vertex x2 = new Vertex( 6, 0, 0);
      x1.setColor(Color.red);
      x2.setColor(Color.red);
      Vertex y1 = new Vertex(0, 0, 0);
      Vertex y2 = new Vertex(0, 6, 0);
      y1.setColor(Color.red);
      y2.setColor(Color.red);
      Vertex z1 = new Vertex(0, 0, -7);
      Vertex z2 = new Vertex(0, 0,  7);
      z1.setColor(Color.red);
      z2.setColor(Color.red);
      xzPlane.addLineSegment( new LineSegment(x1, x2) );
      xzPlane.addLineSegment( new LineSegment(y1, y2) );
      xzPlane.addLineSegment( new LineSegment(z1, z2) );


      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Add the models to the Scene.
      for (int i = 0; i < models.length; i++)
      {
         scene.addModel(models[i]);
      }
      scene.addModel(xzPlane);


      // Create a Camera object.
      Camera camera = new Camera();

      // Give the Camera a view matrix.
      camera.view2Identity();

      // Set up the camera's view frustum.
      double fov    = 25.0;
      double aspect = 2.0;
      double near   = 1.0;
      double far    = 20.0;
      camera.projPerspective(fov, aspect, near, far);

      // Set up the scene's "camera".
      double eyex=3,    eyey=3,    eyez=14;
      double centerx=0, centery=0, centerz=0;
      double upx=0,     upy=1,     upz=0;
      camera.viewLookAt(eyex,    eyey,    eyez,
                        centerx, centery, centerz,
                        upx,     upy,     upz);

      // Add the Camera to the Scene.
      scene.setCamera(camera);

      // Create a framebuffer to render our scene into.
      int vp_width  = 1200;
      int vp_height = 600;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(java.awt.Color.black);
      // Create a default rendering pipeline.
      SceneRender renderer = new SceneRender();

      long startTime, stopTime;
      startTime = System.currentTimeMillis();
      for (int i = 0; i <= 360; i++)
      {
         // Render
         fb.clearFB(java.awt.Color.black);
         renderer.renderScene(scene, fb);
         fb.dumpFB2File(String.format("PPM_Geometries_Frame%03d.ppm", i));

         // rotate each of the models on its own axis
         for (int k = 0; k < models.length; k++)
         {
            models[k].getSubModel(0).modelRotate(2, 1,0,0);
            models[k].getSubModel(0).modelRotate(2, 0,1,0);
         }

         camera.viewRotate(1.0, 0,1,0);
      }
      stopTime = System.currentTimeMillis();
      System.out.println("Wall-clock time: " + (stopTime - startTime));
   }
}