/**
   This file builds a nested model out of two copies of SimpleModel.

   The scene graph is

             SimpleModel2
                 /  \
               /      \
             /          \
      SimpleModel   SimpleModel
*/
import java.awt.Color;

public class SimpleModel2 extends Model
{
   public SimpleModel2(Color c1, Color c2)
   {
      super();

      Model m1 = new SimpleModel();
      Model m2 = new SimpleModel();
      m1.setColor(c1);
      m2.setColor(c2);

      m2.modelTranslate(1.0, -2.0-Math.sqrt(2.0), 0.0);
      m2.modelScale(0.5, 0.5, 1.0);
      m2.modelRotate(-45.0, 0.0, 0.0, 1.0);

      this.addSubModel(m1);
      this.addSubModel(m2);
   }
}